"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.close = exports.create = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _pouchdbBrowser = _interopRequireDefault(require("pouchdb-browser"));

var _fastJsonStableStringify = _interopRequireDefault(require("fast-json-stable-stringify"));

var _getWithDefaultValue = _interopRequireDefault(require("./getWithDefaultValue"));

var dbs = new Map();
var userCounts = new Map();

var withOptionsObject = function withOptionsObject(f) {
  return function (options) {
    return f(typeof options === 'string' ? {
      name: options
    } : options);
  };
};

var create = withOptionsObject(function (_ref) {
  var maxListeners = _ref.maxListeners,
      options = (0, _objectWithoutProperties2.default)(_ref, ["maxListeners"]);
  var key = (0, _fastJsonStableStringify.default)(options);

  var db = _getWithDefaultValue.default.call(dbs, key, function () {
    var db = new _pouchdbBrowser.default(typeof options === 'string' ? options : // PouchDB constructor modifies the options object. Make a copy, so
    // the original object remains untouched.
    (0, _objectSpread2.default)({}, options));

    if (maxListeners) {
      db.setMaxListeners(maxListeners);
    }

    return db;
  });

  var userCount = _getWithDefaultValue.default.call(userCounts, key, function () {
    return 0;
  });

  userCounts.set(key, userCount + 1);
  return db;
});
exports.create = create;
var close = withOptionsObject(function (_ref2) {
  var maxListeners = _ref2.maxListeners,
      options = (0, _objectWithoutProperties2.default)(_ref2, ["maxListeners"]);
  var key = (0, _fastJsonStableStringify.default)(options);
  var userCount = userCounts.get(key) - 1;
  userCounts.set(key, userCount);

  if (!userCount) {
    dbs.get(key).close();
    dbs.delete(key);
  }
});
exports.close = close;
//# sourceMappingURL=pouchdbConnections.js.map