"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.compose = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var react = _interopRequireWildcard(require("react"));

var compose = function compose() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$useEffect = _ref.useEffect,
      useEffect = _ref$useEffect === void 0 ? react.useEffect : _ref$useEffect,
      _ref$useRef = _ref.useRef,
      useRef = _ref$useRef === void 0 ? react.useRef : _ref$useRef,
      _ref$useState = _ref.useState,
      useState = _ref$useState === void 0 ? react.useState : _ref$useState;

  return function useStateIfMounted() {
    var isMountRef = useRef();

    var _useState = useState.apply(void 0, arguments),
        _useState2 = (0, _slicedToArray2.default)(_useState, 2),
        value = _useState2[0],
        setValue = _useState2[1];

    useEffect(function () {
      isMountRef.current = true;
      return function () {
        isMountRef.current = false;
      };
    });
    return [value, function (value) {
      if (isMountRef.current) {
        setValue(value);
      }

      return isMountRef.current;
    }];
  };
};

exports.compose = compose;

var _default = compose();

exports.default = _default;
//# sourceMappingURL=useStateIfMounted.js.map