"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = changesCache;
exports.cache = void 0;

var _fastJsonStableStringify = _interopRequireDefault(require("fast-json-stable-stringify"));

var _getWithDefaultValue = _interopRequireDefault(require("./getWithDefaultValue"));

var cache = new Map();
exports.cache = cache;
var EVENT = 'change';

function changesCache(options, handleChange) {
  var _this = this;

  var dbCache = _getWithDefaultValue.default.call(cache, this, function () {
    return new Map();
  });

  var key = (0, _fastJsonStableStringify.default)(options);

  var listener = _getWithDefaultValue.default.call(dbCache, key, function () {
    return {
      eventEmitter: _this.changes(options),
      count: 0
    };
  });

  var eventEmitter = listener.eventEmitter;
  listener.count = listener.count + 1;
  eventEmitter.on(EVENT, handleChange);
  return function cancel() {
    listener.count = listener.count - 1;

    if (listener.count) {
      eventEmitter.removeListener(EVENT, handleChange);
    } else {
      eventEmitter.cancel();
      dbCache.delete(key);
    }
  };
}
//# sourceMappingURL=changesCache.js.map