"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = useGet;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _attachmentsAsUint8Arrays = _interopRequireDefault(require("./attachmentsAsUint8Arrays"));

var _changesCache = _interopRequireDefault(require("./changesCache"));

var _useDB = _interopRequireDefault(require("./useDB"));

var _useListen = _interopRequireDefault(require("./useListen"));

var UINT8ARRAY = 'u8a';
var ALLOWED_LIVE_OPTIONS = ['attachments', 'ajax', 'binary', 'id'];

function nextState(_x, _x2) {
  return _nextState.apply(this, arguments);
}

function _nextState() {
  _nextState = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee3(binary, doc) {
    return _regenerator.default.wrap(function _callee3$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            if (!(binary && doc)) {
              _context4.next = 11;
              break;
            }

            _context4.t1 = _objectSpread2.default;
            _context4.t2 = {};
            _context4.t3 = doc;
            _context4.next = 6;
            return (0, _attachmentsAsUint8Arrays.default)(doc._attachments);

          case 6:
            _context4.t4 = _context4.sent;
            _context4.t5 = {
              _attachments: _context4.t4
            };
            _context4.t0 = (0, _context4.t1)(_context4.t2, _context4.t3, _context4.t5);
            _context4.next = 12;
            break;

          case 11:
            _context4.t0 = doc;

          case 12:
            return _context4.abrupt("return", _context4.t0);

          case 13:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee3, this);
  }));
  return _nextState.apply(this, arguments);
}

function useGet(db) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : db;

  if (arguments.length < 2) {
    db = undefined;
  }

  db = (0, _useDB.default)(db, {
    callee: 'useGet',
    example: 'useGet(db, options)'
  });
  var id = options.id,
      attachments = options.attachments,
      otherOptions = (0, _objectWithoutProperties2.default)(options, ["id", "attachments"]);
  var binary = attachments === UINT8ARRAY;
  var optionsWithAttachmentAndBinaryOption = (0, _objectSpread2.default)({
    binary: binary
  }, otherOptions, {
    attachments: !!attachments
  });
  return (0, _useListen.default)(db, options,
  /*#__PURE__*/
  (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee() {
    var doc;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return db.get(id, (0, _objectSpread2.default)({}, optionsWithAttachmentAndBinaryOption, {
              local_seq: true
            }));

          case 3:
            doc = _context.sent;
            _context.next = 8;
            break;

          case 6:
            _context.prev = 6;
            _context.t0 = _context["catch"](0);

          case 8:
            return _context.abrupt("return", nextState(binary, doc));

          case 9:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this, [[0, 6]]);
  })), function (doc, setDoc) {
    // Live?
    if (Object.keys(options).every(function (option) {
      return ALLOWED_LIVE_OPTIONS.includes(option);
    })) {
      var _context2;

      return (_context2 = db, _changesCache.default).call(_context2, (0, _objectSpread2.default)({}, optionsWithAttachmentAndBinaryOption, {
        live: true,
        include_docs: true,
        since: doc === null || doc === void 0 ? void 0 : doc._local_seq,
        doc_ids: [id]
      }),
      /*#__PURE__*/
      function () {
        var _ref3 = (0, _asyncToGenerator2.default)(
        /*#__PURE__*/
        _regenerator.default.mark(function _callee2(_ref2) {
          var doc;
          return _regenerator.default.wrap(function _callee2$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  doc = _ref2.doc;
                  _context3.t0 = setDoc;
                  _context3.next = 4;
                  return nextState(binary, doc);

                case 4:
                  _context3.t1 = _context3.sent;
                  return _context3.abrupt("return", (0, _context3.t0)(_context3.t1));

                case 6:
                case "end":
                  return _context3.stop();
              }
            }
          }, _callee2, this);
        }));

        return function (_x3) {
          return _ref3.apply(this, arguments);
        };
      }());
    }
  });
}
//# sourceMappingURL=useGet.js.map