"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = withDB;

var _react = _interopRequireWildcard(require("react"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));

var _useDB = _interopRequireDefault(require("./useDB"));

function withDB(db) {
  var Component = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : db;

  if (arguments.length < 2) {
    db = undefined;
  }

  return (0, _react.forwardRef)((0, _hoistNonReactStatics.default)(Object.assign(function (props, ref) {
    return _react.default.createElement(Component, (0, _extends2.default)({}, props, {
      db: (0, _useDB.default)(db, {
        callee: 'withDB',
        example: 'withDB(name|options, Component)'
      }),
      ref: ref
    }));
  }, {
    displayName: "withDB(".concat(Component.displayName || Component.name, ")"),
    WrappedComponent: Component
  }), Component));
}
//# sourceMappingURL=withDB.js.map