import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import * as react from 'react';
export var compose = function compose() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$useEffect = _ref.useEffect,
      useEffect = _ref$useEffect === void 0 ? react.useEffect : _ref$useEffect,
      _ref$useRef = _ref.useRef,
      useRef = _ref$useRef === void 0 ? react.useRef : _ref$useRef,
      _ref$useState = _ref.useState,
      useState = _ref$useState === void 0 ? react.useState : _ref$useState;

  return function useStateIfMounted() {
    var isMountRef = useRef();

    var _useState = useState.apply(void 0, arguments),
        _useState2 = _slicedToArray(_useState, 2),
        value = _useState2[0],
        setValue = _useState2[1];

    useEffect(function () {
      isMountRef.current = true;
      return function () {
        isMountRef.current = false;
      };
    });
    return [value, function (value) {
      if (isMountRef.current) {
        setValue(value);
      }

      return isMountRef.current;
    }];
  };
};
export default compose();
//# sourceMappingURL=useStateIfMounted.js.map