"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = useDB;

var _react = require("react");

var _pouchdbNode = _interopRequireDefault(require("pouchdb-node"));

var _DBContext = _interopRequireDefault(require("./DBContext"));

var _pouchdbConnections = require("./pouchdbConnections");

function useDB(db) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref$callee = _ref.callee,
      callee = _ref$callee === void 0 ? 'useDB' : _ref$callee,
      _ref$example = _ref.example,
      example = _ref$example === void 0 ? 'useDB(options)' : _ref$example;

  if (db) {
    if (db instanceof _pouchdbNode.default) {
      return db;
    }

    return (0, _pouchdbConnections.create)(db);
  }

  var dbContext = (0, _react.useContext)(_DBContext.default);

  if (dbContext) {
    return dbContext;
  }

  throw new Error(callee ? "`".concat(callee, "` was called without `db` and database is not in context. Provide database using <PouchDB /> or `").concat(example, "`") : 'Database is not in context. Provide database using <PouchDB />');
}
//# sourceMappingURL=useDB.js.map