"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = useListen;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classPrivateFieldSet2 = _interopRequireDefault(require("@babel/runtime/helpers/classPrivateFieldSet"));

var _classPrivateFieldGet2 = _interopRequireDefault(require("@babel/runtime/helpers/classPrivateFieldGet"));

var _react = require("react");

var _fastJsonStableStringify = _interopRequireDefault(require("fast-json-stable-stringify"));

var _getWithDefaultValue = _interopRequireDefault(require("./getWithDefaultValue"));

var _useStateIfMounted3 = _interopRequireDefault(require("./useStateIfMounted"));

var databaseRequests = new Map();

var Request =
/*#__PURE__*/
function () {
  function Request(_ref) {
    var _this = this;

    var optionsKey = _ref.optionsKey,
        requests = _ref.requests;
    (0, _classCallCheck2.default)(this, Request);

    _listenerCount.set(this, {
      writable: true,
      value: 0
    });

    (0, _defineProperty2.default)(this, "removeRequestIfNoListeners", function () {
      if (!(0, _classPrivateFieldGet2.default)(_this, _listenerCount)) {
        _this.requests.delete(_this.optionsKey);
      }
    });
    this.requests = requests;
    this.optionsKey = optionsKey;
  }

  (0, _createClass2.default)(Request, [{
    key: "resetCleanupTimer",
    value: function resetCleanupTimer() {
      clearTimeout(this.timeout);
      this.timeout = setTimeout(this.removeRequestIfNoListeners, 10000);
    }
  }, {
    key: "increaseListenerCount",
    value: function increaseListenerCount() {
      (0, _classPrivateFieldSet2.default)(this, _listenerCount, (0, _classPrivateFieldGet2.default)(this, _listenerCount) + 1);
    }
  }, {
    key: "decreaseListenerCount",
    value: function decreaseListenerCount() {
      (0, _classPrivateFieldSet2.default)(this, _listenerCount, (0, _classPrivateFieldGet2.default)(this, _listenerCount) - 1);
      this.removeRequestIfNoListeners();
    }
  }]);
  return Request;
}();

var _listenerCount = new WeakMap();

function useListen(db, options, get, listener) {
  var requests = _getWithDefaultValue.default.call(databaseRequests, db, function () {
    return new Map();
  });

  var optionsKey = (0, _fastJsonStableStringify.default)(options);

  var request = _getWithDefaultValue.default.call(requests, optionsKey, function () {
    return new Request({
      optionsKey: optionsKey,
      requests: requests
    });
  });

  if (!('value' in request)) {
    request.value = (0, _asyncToGenerator2.default)(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee() {
      return _regenerator.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return get();

            case 2:
              request.value = _context.sent;

            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }))();
  }

  var value = request.value;

  if (Promise.resolve(value) === value) {
    request.resetCleanupTimer();
    throw value;
  }

  var _useStateIfMounted = (0, _useStateIfMounted3.default)(),
      _useStateIfMounted2 = (0, _slicedToArray2.default)(_useStateIfMounted, 2),
      _ = _useStateIfMounted2[0],
      setState = _useStateIfMounted2[1];

  (0, _react.useEffect)(function () {
    request.increaseListenerCount();
    var cancel = listener(value, function (value) {
      request.value = value;
      setState(value);
    });
    return function () {
      request.decreaseListenerCount();
      cancel();
    };
  }, [db, optionsKey]);
  return value;
}
//# sourceMappingURL=useListen.js.map