import _objectSpread from "@babel/runtime/helpers/objectSpread";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import PouchDB from "pouchdb-node";
import stringify from 'fast-json-stable-stringify';
import get from './getWithDefaultValue';
var dbs = new Map();
var userCounts = new Map();

var withOptionsObject = function withOptionsObject(f) {
  return function (options) {
    return f(typeof options === 'string' ? {
      name: options
    } : options);
  };
};

export var create = withOptionsObject(function (_ref) {
  var maxListeners = _ref.maxListeners,
      options = _objectWithoutProperties(_ref, ["maxListeners"]);

  var key = stringify(options);
  var db = get.call(dbs, key, function () {
    var db = new PouchDB(typeof options === 'string' ? options : // PouchDB constructor modifies the options object. Make a copy, so
    // the original object remains untouched.
    _objectSpread({}, options));

    if (maxListeners) {
      db.setMaxListeners(maxListeners);
    }

    return db;
  });
  var userCount = get.call(userCounts, key, function () {
    return 0;
  });
  userCounts.set(key, userCount + 1);
  return db;
});
export var close = withOptionsObject(function (_ref2) {
  var maxListeners = _ref2.maxListeners,
      options = _objectWithoutProperties(_ref2, ["maxListeners"]);

  var key = stringify(options);
  var userCount = userCounts.get(key) - 1;
  userCounts.set(key, userCount);

  if (!userCount) {
    dbs.get(key).close();
    dbs.delete(key);
  }
});
//# sourceMappingURL=pouchdbConnections.js.map