import { useContext } from 'react';
import PouchDB from "pouchdb-node";
import DBContext from './DBContext';
import { create } from './pouchdbConnections';
export default function useDB(db) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref$callee = _ref.callee,
      callee = _ref$callee === void 0 ? 'useDB' : _ref$callee,
      _ref$example = _ref.example,
      example = _ref$example === void 0 ? 'useDB(options)' : _ref$example;

  if (db) {
    if (db instanceof PouchDB) {
      return db;
    }

    return create(db);
  }

  var dbContext = useContext(DBContext);

  if (dbContext) {
    return dbContext;
  }

  throw new Error(callee ? "`".concat(callee, "` was called without `db` and database is not in context. Provide database using <PouchDB /> or `").concat(example, "`") : 'Database is not in context. Provide database using <PouchDB />');
}
//# sourceMappingURL=useDB.js.map