import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _classPrivateFieldSet from "@babel/runtime/helpers/classPrivateFieldSet";
import _classPrivateFieldGet from "@babel/runtime/helpers/classPrivateFieldGet";
import { useEffect } from 'react';
import stringify from 'fast-json-stable-stringify';
import getWithDefaultValue from './getWithDefaultValue';
import useStateIfMounted from './useStateIfMounted';
var databaseRequests = new Map();

var Request =
/*#__PURE__*/
function () {
  function Request(_ref) {
    var _this = this;

    var optionsKey = _ref.optionsKey,
        requests = _ref.requests;

    _classCallCheck(this, Request);

    _listenerCount.set(this, {
      writable: true,
      value: 0
    });

    _defineProperty(this, "removeRequestIfNoListeners", function () {
      if (!_classPrivateFieldGet(_this, _listenerCount)) {
        _this.requests.delete(_this.optionsKey);
      }
    });

    this.requests = requests;
    this.optionsKey = optionsKey;
  }

  _createClass(Request, [{
    key: "resetCleanupTimer",
    value: function resetCleanupTimer() {
      clearTimeout(this.timeout);
      this.timeout = setTimeout(this.removeRequestIfNoListeners, 10000);
    }
  }, {
    key: "increaseListenerCount",
    value: function increaseListenerCount() {
      _classPrivateFieldSet(this, _listenerCount, _classPrivateFieldGet(this, _listenerCount) + 1);
    }
  }, {
    key: "decreaseListenerCount",
    value: function decreaseListenerCount() {
      _classPrivateFieldSet(this, _listenerCount, _classPrivateFieldGet(this, _listenerCount) - 1);

      this.removeRequestIfNoListeners();
    }
  }]);

  return Request;
}();

var _listenerCount = new WeakMap();

export default function useListen(db, options, get, listener) {
  var requests = getWithDefaultValue.call(databaseRequests, db, function () {
    return new Map();
  });
  var optionsKey = stringify(options);
  var request = getWithDefaultValue.call(requests, optionsKey, function () {
    return new Request({
      optionsKey: optionsKey,
      requests: requests
    });
  });

  if (!('value' in request)) {
    request.value = _asyncToGenerator(
    /*#__PURE__*/
    _regeneratorRuntime.mark(function _callee() {
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return get();

            case 2:
              request.value = _context.sent;

            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }))();
  }

  var value = request.value;

  if (Promise.resolve(value) === value) {
    request.resetCleanupTimer();
    throw value;
  }

  var _useStateIfMounted = useStateIfMounted(),
      _useStateIfMounted2 = _slicedToArray(_useStateIfMounted, 2),
      _ = _useStateIfMounted2[0],
      setState = _useStateIfMounted2[1];

  useEffect(function () {
    request.increaseListenerCount();
    var cancel = listener(value, function (value) {
      request.value = value;
      setState(value);
    });
    return function () {
      request.decreaseListenerCount();
      cancel();
    };
  }, [db, optionsKey]);
  return value;
}
//# sourceMappingURL=useListen.js.map